// Auto-generated from armory.html.
// DO NOT EDIT.

library armory_html;

import 'dart:html' as autogenerated;
import 'dart:svg' as autogenerated_svg;
import 'package:web_ui/web_ui.dart' as autogenerated;
import 'package:web_ui/observe/observable.dart' as __observe;
import 'weapon.html.dart';
import 'armor.html.dart';
import "dart:html";
import 'package:web_ui/watcher.dart' as watcher;
import '../config.dart';
import '../jao.dart';


// Original code


main() {
 
}

void OnLoadPackageClicked(MouseEvent e)
{
  var button = e.currentTarget as Element;
  var packageToLoad = button.id;
  StartLoadingPackage(packageToLoad);
}

DataLoader Loader;

void StartLoadingPackage(String package)
{
  Loader = new DataLoader(Config.BaseUrl, package);
  Loader.DataLoaded.stream.listen(OnDataLoaded);
  
  Loader.Start();
}

List<ISortableItem> CurrentSortableCollection;  

void OnDataLoaded(String data)
{
  switch(data)
  {
    case DataLoader.LocalizedText:
      Loca = Loader.Loca;
      break;
      
    case DataLoader.Weapons:
      CurrentWeapons = Loader.WeaponData.toList();
      break;
      
    case DataLoader.SubCategories:
      CurrentSubCategories = Loader.SubCategoryData.toList();
      break;
      
    case DataLoader.Armors:
      CurrentArmors = Loader.ArmorData.toList();
      break;
  }
  watcher.dispatch();
}

void ReSort()
{
  var sortAlgrithm = SortMode == 'asc' ? SortAlgorithmAscending : SortAlgorithmDescending;
  CurrentSortableCollection.sort(sortAlgrithm);
}

void OnSortParameterChanged()
{
  ReSort();
}

void OnMainCategorySelected(MouseEvent event)
{  
  var li = event.currentTarget as LIElement;
  SelectMainCategory(li.id);
}

void SelectMainCategory(String id)
{
  switch(id)
  {
    case MainCategory.Weapon:
      CurrentDisplayingItems = CurrentWeapons;
      CurrentSortableCollection = CurrentWeapons;
      break;
    case MainCategory.Armor:
      CurrentDisplayingItems = CurrentArmors;
      CurrentSortableCollection = CurrentArmors;
      break;
  }
  CurrentMainCategory = id;
  SelectedSubCategory = CurrentSubCategories.firstWhere((s) => s.MainCategory == CurrentMainCategory).id;
  SelectedSortProperty = "Level";
  ReSort();
}

List<Weapon> CurrentWeapons;
Localization Loca;
List<SubCategory> CurrentSubCategories;
List<Armor> CurrentArmors;

String NameFilter = "";
var qualityLevels = Quality.Levels;
String SelectedQuality = "";
bool ShopOnly = false;
bool EmergencyShopOnly = false;

String SelectedSubCategory = "2";
String SelectedSortProperty = "Level";
String SortMode = 'asc';
String CurrentMainCategory = MainCategory.Weapon;
List<IFilterableItem> CurrentDisplayingItems;

bool ApplyFilter(IFilterableItem item)
{
  return (NameFilter == "" || Loca.Get(item.Name).toLowerCase().contains(NameFilter.toLowerCase())) 
      && (SelectedQuality == "" || item.QualityLevel == SelectedQuality)
      && (SelectedSubCategory == "" || item.ItemCategory == SelectedSubCategory)
      && (!ShopOnly || item.IsInShop)
      && (!EmergencyShopOnly || item.IsInEmergencyShop);
}

bool IsSelectedCategory(SubCategory category)
{
  return category.MainCategory == CurrentMainCategory;
}

int SortAlgorithmAscending(ISortableItem a, ISortableItem b)
{
  return a.GetComparableValue(SelectedSortProperty).compareTo(b.GetComparableValue(SelectedSortProperty));
}

int SortAlgorithmDescending(ISortableItem a, ISortableItem b)
{
  return b.GetComparableValue(SelectedSortProperty).compareTo(a.GetComparableValue(SelectedSortProperty));
}
// Additional generated code
void init_autogenerated() {
  var __root = autogenerated.document.body;
  final __html0 = new autogenerated.Element.html('<li class="button"></li>'), __html1 = new autogenerated.Element.html('<li class="button"></li>'), __html10 = new autogenerated.Element.html('<div id="items-container">\n        <template></template>\n      </div>'), __html11 = new autogenerated.Element.tag('template'), __html12 = new autogenerated.Element.html('<div is="jao-weapon"></div>'), __html13 = new autogenerated.Element.tag('template'), __html14 = new autogenerated.Element.html('<div is="jao-armor"></div>'), __html2 = new autogenerated.Element.html('<div id="filter-sorting-container">\n          <div class="item-filter">\n            Filter: <input type="text" placeholder="Search for name here">\n            Quality Level: \n            <select>\n                <option value="" selected="">All</option>\n                <option style="display:none"></option>\n            </select>\n            Category:\n            <select>\n                <option value="">All</option>\n                <option style="display:none"></option>\n            </select>\n            Available in shop:\n            <input type="checkbox">\n            Available in emergency drop:\n            <input type="checkbox">\n          </div>\n          \n          <div class="item-sort">\n            Sort By\n            <select>\n              <option style="display:none"></option>\n            </select>\n            <select>\n              <option value="asc">Ascending</option>\n              <option value="dsc">Descending</option>\n            </select>\n          </div>\n        </div>'), __html3 = new autogenerated.Element.html('<option template="" repeat="quality in Quality.Levels.values"></option>'), __html4 = new autogenerated.Element.html('<option template="" repeat="category in CurrentSubCategories.where(IsSelectedCategory)"></option>'), __html5 = new autogenerated.Element.html('<option template="" repeat="field in CurrentSortableCollection.first.AvailableSortFields"></option>'), __html6 = new autogenerated.Element.html('<div id="package-chooser">\n          Choose Package:\n          <ul class="button-list">\n            <template></template>\n          </ul>\n          <div style="clear:left;"></div>\n        </div>'), __html7 = new autogenerated.Element.html('<li class="button"></li>'), __html8 = new autogenerated.Element.tag('template'), __html9 = new autogenerated.Element.html('<div id="newest-package">Newest</div>');
  var __e24, __e30, __e37, __e4;
  var __t = new autogenerated.Template(__root);
  __e4 = __root.nodes[1].nodes[1].nodes[1].nodes[3];
  __t.conditional(__e4, () => CurrentWeapons != null && CurrentArmors != null, (__t) {
    var __e1, __e3;
    __e1 = __html0.clone(true);
    var __binding0 = __t.contentBind(() => CurrentWeapons.length, false);
    __e1.nodes.addAll([new autogenerated.Text('\n               Weapons ('),
        __binding0,
        new autogenerated.Text(')\n            ')]);
    __t.listen(__e1.onClick, ($event) { OnMainCategorySelected($event); });
    __t.oneWayBind(() => MainCategory.Weapon, (e) { if (__e1.id != e) __e1.id = e; }, false, false);
    __e3 = __html1.clone(true);
    var __binding2 = __t.contentBind(() => CurrentArmors.length, false);
    __e3.nodes.addAll([new autogenerated.Text('\n                Armors ('),
        __binding2,
        new autogenerated.Text(')\n            ')]);
    __t.listen(__e3.onClick, ($event) { OnMainCategorySelected($event); });
    __t.oneWayBind(() => MainCategory.Armor, (e) { if (__e3.id != e) __e3.id = e; }, false, false);
  __t.addAll([new autogenerated.Text('\n            '),
      __e1,
      new autogenerated.Text('\n            '),
      __e3,
      new autogenerated.Text('\n          ')]);
  });

  __e24 = __root.nodes[1].nodes[3];
  __t.conditional(__e24, () => CurrentDisplayingItems != null && CurrentSubCategories != null && Loca != null, (__t) {
    var __e12, __e13, __e14, __e15, __e18, __e19, __e20, __e21, __e22, __e23, __e5, __e8, __e9;
    __e23 = __html2.clone(true);
    __e5 = __e23.nodes[1].nodes[1];
    __t.listen(__e5.onInput, ($event) { NameFilter = __e5.value; });
    __t.oneWayBind(() => NameFilter, (e) { if (__e5.value != e) __e5.value = e; }, false, false);
    __e9 = __e23.nodes[1].nodes[3];
    __e8 = __e9.nodes[3];
    __t.loop(__e8, () => Quality.Levels.values, ($list, $index, __t) {
      var quality = $list[$index];
      var __e7;
      __e7 = __html3.clone(true);
      var __binding6 = __t.contentBind(() => Loca.Get(quality.id), false);
      __e7.nodes.add(__binding6);
      __t.oneWayBind(() => SelectedQuality == quality.id, (e) { if (__e7.selected != e) __e7.selected = e; }, false, false);
      __t.oneWayBind(() => quality.id, (e) { if (__e7.value != e) __e7.value = e; }, false, false);
    __t.add(__e7);
    });
    __t.listen(__e9.onChange, ($event) { SelectedQuality = __e9.value; });
    __t.oneWayBind(() => SelectedQuality, (e) { if (__e9.value != e) __e9.value = e; }, false, false);
    __e13 = __e23.nodes[1].nodes[5];
    __e12 = __e13.nodes[3];
    __t.loop(__e12, () => CurrentSubCategories.where(IsSelectedCategory), ($list, $index, __t) {
      var category = $list[$index];
      var __e11;
      __e11 = __html4.clone(true);
      var __binding10 = __t.contentBind(() => Loca.Get(category.Name), false);
      __e11.nodes.add(__binding10);
      __t.oneWayBind(() => category.id, (e) { if (__e11.value != e) __e11.value = e; }, false, false);
    __t.add(__e11);
    });
    __t.listen(__e13.onChange, ($event) { SelectedSubCategory = __e13.value; });
    __t.oneWayBind(() => SelectedSubCategory, (e) { if (__e13.value != e) __e13.value = e; }, false, false);
    __e14 = __e23.nodes[1].nodes[7];
    __t.listen(__e14.onChange, ($event) { ShopOnly = __e14.checked; });
    __t.oneWayBind(() => ShopOnly, (e) { if (__e14.checked != e) __e14.checked = e; }, false, false);
    __e15 = __e23.nodes[1].nodes[9];
    __t.listen(__e15.onChange, ($event) { EmergencyShopOnly = __e15.checked; });
    __t.oneWayBind(() => EmergencyShopOnly, (e) { if (__e15.checked != e) __e15.checked = e; }, false, false);
    __e19 = __e23.nodes[3].nodes[1];
    __e18 = __e19.nodes[1];
    __t.loop(__e18, () => CurrentSortableCollection.first.AvailableSortFields, ($list, $index, __t) {
      var field = $list[$index];
      var __e17;
      __e17 = __html5.clone(true);
      var __binding16 = __t.contentBind(() => field, false);
      __e17.nodes.add(__binding16);
      __t.oneWayBind(() => SelectedSortProperty == field, (e) { if (__e17.selected != e) __e17.selected = e; }, false, false);
      __t.oneWayBind(() => field, (e) { if (__e17.value != e) __e17.value = e; }, false, false);
    __t.add(__e17);
    });
    __t.listen(__e19.onChange, ($event) { SelectedSortProperty = __e19.value; });
    __t.listen(__e19.onChange, ($event) { OnSortParameterChanged(); });
    __t.oneWayBind(() => SelectedSortProperty, (e) { if (__e19.value != e) __e19.value = e; }, false, false);
    __e22 = __e23.nodes[3].nodes[3];
    __e20 = __e22.nodes[1];
    __t.oneWayBind(() => SortMode == 'asc', (e) { if (__e20.selected != e) __e20.selected = e; }, false, false);
    __e21 = __e22.nodes[3];
    __t.oneWayBind(() => SortMode == 'dsc', (e) { if (__e21.selected != e) __e21.selected = e; }, false, false);
    __t.listen(__e22.onChange, ($event) { SortMode = __e22.value; });
    __t.listen(__e22.onChange, ($event) { OnSortParameterChanged(); });
    __t.oneWayBind(() => SortMode, (e) { if (__e22.value != e) __e22.value = e; }, false, false);
  __t.addAll([new autogenerated.Text('\n        '),
      __e23,
      new autogenerated.Text('\n      ')]);
  });

  __e30 = __root.nodes[1].nodes[5];
  __t.conditional(__e30, () => CurrentWeapons == null || Loca == null || CurrentSubCategories == null || CurrentArmors == null || Loader.ArmorOpticsData == null, (__t) {
    var __e28, __e29;
    __e29 = __html6.clone(true);
    __e28 = __e29.nodes[1].nodes[1];
    __t.loop(__e28, () => DataLoader.AvailablePackages, ($list, $index, __t) {
      var package = $list[$index];
      var __e25, __e27;
      __e27 = __html7.clone(true);
      __e25 = __html8.clone(true);
      __t.conditional(__e25, () => DataLoader.NewestPackage == package, (__t) {
      __t.addAll([new autogenerated.Text('\n                  '),
          __html9.clone(true),
          new autogenerated.Text(' \n                ')]);
      });

      var __binding26 = __t.contentBind(() => package, false);
      __e27.nodes.addAll([new autogenerated.Text('\n                '),
          __e25,
          new autogenerated.Text('\n                '),
          __binding26,
          new autogenerated.Text('\n              ')]);
      __t.listen(__e27.onClick, ($event) { OnLoadPackageClicked($event); });
      __t.oneWayBind(() => package, (e) { if (__e27.id != e) __e27.id = e; }, false, false);
    __t.addAll([new autogenerated.Text('\n              '),
        __e27,
        new autogenerated.Text('\n            ')]);
    });
  __t.addAll([new autogenerated.Text('\n        '),
      __e29,
      new autogenerated.Text('\n      ')]);
  });

  __e37 = __root.nodes[3];
  __t.conditional(__e37, () => CurrentDisplayingItems != null && CurrentSubCategories != null && Loca != null, (__t) {
    var __e35, __e36;
    __e36 = __html10.clone(true);
    __e35 = __e36.nodes[1];
    __t.loop(__e35, () => CurrentDisplayingItems.where(ApplyFilter), ($list, $index, __t) {
      var item = $list[$index];
      var __e32, __e34;
      __e32 = __html11.clone(true);
      __t.conditional(__e32, () => item is Weapon, (__t) {
        var __e31;
        __e31 = __html12.clone(true);
        __t.oneWayBind(() => Loader.CurrentPackage, (e) { if (__e31.xtag.currentpackage != e) __e31.xtag.currentpackage = e; }, false, false);
        __t.oneWayBind(() => item as Weapon, (e) { if (__e31.xtag.instance != e) __e31.xtag.instance = e; }, false, false);
        __t.oneWayBind(() => Loca, (e) { if (__e31.xtag.loca != e) __e31.xtag.loca = e; }, false, false);
        __t.component(new JaoWeapon()..host = __e31);
      __t.addAll([new autogenerated.Text('\n                '),
          __e31,
          new autogenerated.Text('\n             ')]);
      });

      __e34 = __html13.clone(true);
      __t.conditional(__e34, () => item is Armor, (__t) {
        var __e33;
        __e33 = __html14.clone(true);
        __t.oneWayBind(() => Loader.CurrentPackage, (e) { if (__e33.xtag.currentpackage != e) __e33.xtag.currentpackage = e; }, false, false);
        __t.oneWayBind(() => item as Armor, (e) { if (__e33.xtag.instance != e) __e33.xtag.instance = e; }, false, false);
        __t.oneWayBind(() => Loca, (e) { if (__e33.xtag.loca != e) __e33.xtag.loca = e; }, false, false);
        __t.component(new JaoArmor()..host = __e33);
      __t.addAll([new autogenerated.Text('\n                '),
          __e33,
          new autogenerated.Text('\n             ')]);
      });

    __t.addAll([new autogenerated.Text('\n             '),
        __e32,
        new autogenerated.Text('\n             \n             '),
        __e34,
        new autogenerated.Text('\n        ')]);
    });
  __t.addAll([new autogenerated.Text('\n      '),
      __e36,
      new autogenerated.Text('\n    ')]);
  });

  __t.create();
  __t.insert();
}

//@ sourceMappingURL=armory.dart.map